#!/usr/bin/perl

$FROM_SIZE = 0;		# Size of articles from feed.
$FROM_COUNT = 1;	# Count...

$colldate = 0;
$colltime = 0;


sub dumphour {
    foreach $fromhost (keys %fromstats) {
	printf STATO ("$colldate $colltime %9d %6d %s\n",
			$fromstats{$fromhost}[$FROM_SIZE],
			$fromstats{$fromhost}[$FROM_COUNT],
			$fromhost);
    }
    %fromstats = ();
}


foreach $INPUT (@ARGV) {
    $INPUT =~ /^fromhour\.[0-9]{6}\.[0-9]{4}/ ||
	die "Invalid input file \"$INPUT\"\n";

    open(INPUT,$INPUT) || die "Cannot open input file \"$INPUT\"\n";

    while (<INPUT>) {
	($h_date, $h_time, $from_size, $from_count, $fromhost) = split;

	if ($h_date != $colldate) {
	    if ($colldate != 0) {
		&dumphour;
		close STATO;
		rename $logname, "fromday.$colldate";
	    }
	    $colldate = $h_date;
	    $colltime = $h_time;
	    $logname = "temp.fromday.$colldate";
	    open (STATO,">$logname") ||
		die "Cannot create output statfile \"$logname\"\n";
	}

	if ($h_time != $colltime) {
	    &dumphour;
	    $colltime = $h_time;
	}

	$fromstats{$fromhost}[$FROM_SIZE]  += $from_size;
	$fromstats{$fromhost}[$FROM_COUNT] += $from_count;

    } # End of while (<INPUT>)

} # End of foreach $INPUT (@ARGV)

if ($colldate != 0) {
    &dumphour;
    close STATO;
    rename $logname, "fromday.$colldate";
}

exit;
